// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _GOOCANVASMM_RECTMODEL_H
#define _GOOCANVASMM_RECTMODEL_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <goocanvasmm/itemmodelsimple.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GooCanvasRectModel GooCanvasRectModel;
typedef struct _GooCanvasRectModelClass GooCanvasRectModelClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Goocanvas
{ class RectModel_Class; } // namespace Goocanvas
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Goocanvas
{


class RectModel :
  public Goocanvas::ItemModelSimple
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef RectModel CppObjectType;
  typedef RectModel_Class CppClassType;
  typedef GooCanvasRectModel BaseObjectType;
  typedef GooCanvasRectModelClass BaseClassType;

  // noncopyable
  RectModel(const RectModel&) = delete;
  RectModel& operator=(const RectModel&) = delete;

private:  friend class RectModel_Class;
  static CppClassType rectmodel_class_;

protected:
  explicit RectModel(const Glib::ConstructParams& construct_params);
  explicit RectModel(GooCanvasRectModel* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  RectModel(RectModel&& src) noexcept;
  RectModel& operator=(RectModel&& src) noexcept;

  virtual ~RectModel() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GooCanvasRectModel*       gobj()       { return reinterpret_cast<GooCanvasRectModel*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GooCanvasRectModel* gobj() const { return reinterpret_cast<GooCanvasRectModel*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GooCanvasRectModel* gobj_copy();

private:


protected:

  RectModel(double x, double y, double width, double height);
  

public:

  
  static Glib::RefPtr<RectModel> create(double x, double y, double width, double height);


  //We put these in item.hg instead.
  //See the comment there.
  //_WRAP_PROPERTY("x", double)
  //_WRAP_PROPERTY("y", double)
  //_WRAP_PROPERTY("width", double)
  //_WRAP_PROPERTY("height", double)
  /** The horizontal radius to use for rounded corners.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_radius_x() ;

/** The horizontal radius to use for rounded corners.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_radius_x() const;

  /** The vertical radius to use for rounded corners.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_radius_y() ;

/** The vertical radius to use for rounded corners.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_radius_y() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

}


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Goocanvas::RectModel
   */
  Glib::RefPtr<Goocanvas::RectModel> wrap(GooCanvasRectModel* object, bool take_copy = false);
}


#endif /* _GOOCANVASMM_RECTMODEL_H */

